from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, String, File

Xs_V0_1_0 = CommandToolBuilder(tool="XS", base_command=["XS"], inputs=[ToolInput(tag="in_verbose_mode", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="verbose mode")), ToolInput(tag="in_sequencingtype_type_roche", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="<sequencingType>     type: 1=Roche-454, 2=Illumina, 3=ABI SOLiD, 4=Ion Torrent")), ToolInput(tag="in_hf", input_type=Int(optional=True), prefix="-hf", doc=InputDocumentation(doc="header format: 1=Length appendix, 2=Pair End")), ToolInput(tag="in_ninstrumentname_unique_use", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="n=<instrumentName>   the unique instrument name (use n= before name)")), ToolInput(tag="in_use_same_header", input_type=Boolean(optional=True), prefix="-o", doc=InputDocumentation(doc="use the same header in third line of the read")), ToolInput(tag="in_ls", input_type=Int(optional=True), prefix="-ls", doc=InputDocumentation(doc="static line (bases/quality scores) size")), ToolInput(tag="in_ld", input_type=Int(optional=True), prefix="-ld", doc=InputDocumentation(doc=":<maxSize>  dynamic line (bases/quality scores) size")), ToolInput(tag="in_numberofreads_number_reads", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="<numberOfReads>      number of reads per file")), ToolInput(tag="in_acgtn_symbols_frequency", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="<A>,<C>,<G>,<T>,<N>  symbols frequency")), ToolInput(tag="in_rn", input_type=Int(optional=True), prefix="-rn", doc=InputDocumentation(doc="repeats: number (default: 0)")), ToolInput(tag="in_ri", input_type=Int(optional=True), prefix="-ri", doc=InputDocumentation(doc="repeats: minimum size")), ToolInput(tag="in_ra", input_type=Int(optional=True), prefix="-ra", doc=InputDocumentation(doc="repeats: maximum size")), ToolInput(tag="in_rm", input_type=String(optional=True), prefix="-rm", doc=InputDocumentation(doc="repeats: mutation frequency")), ToolInput(tag="in_rr", input_type=Boolean(optional=True), prefix="-rr", doc=InputDocumentation(doc="repeats: use reverse complement repeats")), ToolInput(tag="in_qt", input_type=Int(optional=True), prefix="-qt", doc=InputDocumentation(doc="quality scores distribution: 1=uniform, 2=gaussian")), ToolInput(tag="in_qf", input_type=File(optional=True), prefix="-qf", doc=InputDocumentation(doc="load file: mean, standard deviation (when: -qt 2)")), ToolInput(tag="in_qc", input_type=String(optional=True), prefix="-qc", doc=InputDocumentation(doc="custom template ascii alphabet")), ToolInput(tag="in_eh", input_type=Boolean(optional=True), prefix="-eh", doc=InputDocumentation(doc="excludes the use of headers from output")), ToolInput(tag="in_eo", input_type=Boolean(optional=True), prefix="-eo", doc=InputDocumentation(doc="excludes the use of optional headers (+) from output")), ToolInput(tag="in_ed", input_type=Boolean(optional=True), prefix="-ed", doc=InputDocumentation(doc="excludes the use of DNA bases from output")), ToolInput(tag="in_edb", input_type=Boolean(optional=True), prefix="-edb", doc=InputDocumentation(doc="excludes '\n' when DNA bases line size is reached")), ToolInput(tag="in_es", input_type=Boolean(optional=True), prefix="-es", doc=InputDocumentation(doc="excludes the use of quality scores from output")), ToolInput(tag="in_seed_generation_seed", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="<seed>               generation seed"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Xs_V0_1_0().translate("wdl", allow_empty_container=True)

